#pragma once

#include <GLFW/glfw3.h>

#include "utils.h"

namespace kek {

typedef generic_callable_t<GLFWwindow *> PeriodicCallback;
typedef generic_callable_t<GLFWwindow *> KeyCallback;
typedef generic_callable_t<GLFWwindow *, double, double> MouseCallback;

typedef unsigned int InputListener;

}

namespace kek::Input {

InputListener addPeriodicCallback(PeriodicCallback callback);

void removePeriodicCallback(InputListener listener);

InputListener addKeyListener(KeyCallback callback);

void removeKeyListener(InputListener listener);

InputListener addMouseListener(MouseCallback callback);

void removeMouseListener(InputListener listener);

}
