#pragma once

#include "input.h"
#include "camera.h"
#include "scene.h"

#include <map>

namespace kek {

struct KekData {
	std::map<InputListener, PeriodicCallback> periodicCallbacks;
	std::map<InputListener, KeyCallback> keyCallbacks;
	std::map<InputListener, MouseCallback> mouseCallbacks;

	GLFWwindow *window;
	Shader *shader;

	Camera *activeCamera;
	Scene *activeScene;

	int screenWidth;
	int screenHeight;
};

extern KekData kekData;

}
