#pragma once

#include "shader.h"

#include <glm/glm.hpp>
#include <vector>
#include <cstdint>
#include <iostream>

namespace kek {

struct Vertex {
	glm::vec3 pos;
	glm::vec3 normal;
	glm::vec2 texCoords;

	Vertex(glm::vec3 pos, glm::vec3 normal, glm::vec2 texCoords);

};

class Mesh {

public:
	std::vector<Vertex> vertices;
	std::vector<uint32_t> indices;

	unsigned int vao, vbo, ebo;

	Mesh(std::vector<Vertex> vertices, std::vector<uint32_t> indices);

	~Mesh();

	void draw(Shader *shader);

};

}
